/*
-*- Mode: C -*-
 */

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <sys/time.h>
#include <sys/types.h>
#include "param.h"
#include "types.h"
#include "netif.h"

#define	BUF_SIZE	32
#define WAIT		100000

void init(void) ;
void exec(void) ;

Port port ;

int main(void)
{
	init() ;

	exec() ;

	return 0 ;
}

void init(void)
{
	struct timeval timeout ;

	port.init() ;

	printf("\n Wait for monitor!\n") ;

	for ( ; ; ){
		port.recv_info() ;
		if (!strcmp(port.rbuf, "(dispinit)")) 
			break ;
		timeout.tv_sec = 0 ;
		timeout.tv_usec = WAIT ;
		select(0, NULL, NULL, NULL, &timeout) ;
	}
}

void exec(void)
{
	int val ;
	char buf[BUF_SIZE] ;
	dispinfo_t	info ;
	displist_t	*p ;

	info.mode = htons(DRAW_MODE) ;
	p = port.top.next ;

	for ( ; ; ){
		printf("\n Which do you select? (0:Clear, 1:Point, 2:Circle, 3:Line, 5:Quit) ") ; 
		scanf("%d", &val) ;
		switch(val) {
		  case DrawPoint:
			info.body.draw.mode = htons(DrawPoint) ;
			printf("\n x: ") ; 
			scanf("%d", &val) ; 
			info.body.draw.object.pinfo.x = htons(val) ;
			printf("\n y: ") ; 
			scanf("%d", &val) ; 
			info.body.draw.object.pinfo.y = htons(val) ;
			printf("\n color: ") ;
			scanf("%s", buf) ;
			strcpy(info.body.draw.object.pinfo.color, buf) ;
			port.send_info(&info, p->shost, p->sport) ;
			break ;

		  case DrawCircle:
			info.body.draw.mode = htons(DrawCircle) ;
			printf("\n x: ") ; 
			scanf("%d", &val) ; 
			info.body.draw.object.cinfo.x = htons(val) ;
			printf("\n y: ") ; 
			scanf("%d", &val) ; 
			info.body.draw.object.cinfo.y = htons(val) ;
			printf("\n r: ") ; 
			scanf("%d", &val) ; 
			info.body.draw.object.cinfo.r = htons(val) ;
			printf("\n color: ") ;
			scanf("%s", buf) ;
			strcpy(info.body.draw.object.cinfo.color, buf) ;
			port.send_info(&info, p->shost, p->sport) ;
			break ;

		  case DrawLine:
			info.body.draw.mode = htons(DrawLine) ;
			printf("\n x1: ") ; 
			scanf("%d", &val) ; 
			info.body.draw.object.linfo.x1 = htons(val) ;
			printf("\n y1: ") ; 
			scanf("%d", &val) ; 
			info.body.draw.object.linfo.y1 = htons(val) ;
			printf("\n x2: ") ; 
			scanf("%d", &val) ; 
			info.body.draw.object.linfo.x2 = htons(val) ;
			printf("\n y2: ") ; 
			scanf("%d", &val) ; 
			info.body.draw.object.linfo.y2 = htons(val) ;
			printf("\n color: ") ;
			scanf("%s", buf) ;
			strcpy(info.body.draw.object.linfo.color, buf) ;
			port.send_info(&info, p->shost, p->sport) ;
			break ;

		  case DrawClear:
			info.body.draw.mode = htons(DrawClear) ;
			port.send_info(&info, p->shost, p->sport) ;
			break ;

		  default:
			return ;
		}
	}
}
