/* -*- Mode: C++ -*-
 *Header:
 *File: netif.C
 *Author: Noda Itsuki
 *Date: 1996/01/29
 *EndHeader:
 */

#include <X11/Intrinsic.h>

#include <stdio.h>
#include <iostream.h>
#include <errno.h>
#include <string.h>
#ifdef SYSV
#ifndef Solaris
#include <strings.h>
#endif
#endif
#include "param.h"
#include "types.h"
#include "utility.h"
#include "netif.h"
#include "object.h"
#include "field.h"

/*
 *===================================================================
 *Part: Port
 *===================================================================
 */
Port::Port()
{
	strcpy(host, "localhost") ;
	portnum = DEFAULT_PORT_NUMBER ;
}

Bool Port::init(void)
{
	struct hostent		*host_ent ;
	struct in_addr		*addr_ptr ;
	struct sockaddr_in	cli_addr ;

	if ((host_ent = (struct hostent *)gethostbyname(host)) == NULL) {
		/* Check if a numeric address */
		if (inet_addr(host) == 0)
			return FALSE ;
	}
	else{
		addr_ptr = (struct in_addr *) *host_ent->h_addr_list ;
		strcpy(host,inet_ntoa(*addr_ptr)) ;
	}

	/* Open UDP socket */
	if ((socketfd = socket(AF_INET, SOCK_DGRAM, 0)) < 0)
		return FALSE ;	/* Can't open socket. */

	/* Bind any local address */
	bzero((char *)&cli_addr, sizeof(cli_addr)) ;
	cli_addr.sin_family			= AF_INET ;
	cli_addr.sin_addr.s_addr	= htonl(INADDR_ANY) ;
	cli_addr.sin_port			= htons(0) ;

	if (bind(socketfd, (struct sockaddr *)&cli_addr, sizeof(cli_addr)) < 0)
		return FALSE ;

	/* Fill in the structure with the address of the server  */
	bzero((char *) &serv_addr, sizeof(serv_addr)) ;
	serv_addr.sin_family		= AF_INET ;
	serv_addr.sin_addr.s_addr	= inet_addr(host) ;
	serv_addr.sin_port			= htons(portnum) ;

	return send_info("(dispinit)") ;
}

Bool Port::send_info(char *msg)
{
	int n = strlen(msg) ;

	if (sendto(socketfd, msg, n, 0,
				(struct sockaddr *)&serv_addr, sizeof(serv_addr)) != n)
		return FALSE ;

	return TRUE ;
}

char Port::recv_info(void)
{
	int n, servlen ;

	servlen = sizeof(serv_addr) ;
	n = recvfrom(socketfd, (char *)(&rinfo), sizeof(rinfo), 0,
				(struct sockaddr *)&serv_addr, &servlen) ;

	return (n >= 0) ? ntohs(rinfo.mode) : NO_INFO ;
}
